//+------------------------------------------------------------------+
//|                                           T3 tma combination.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 LimeGreen
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame              = "Current time frame";
extern int    T3Price                = PRICE_CLOSE;
extern int    T3Period               = 14;
extern double T3Hot                  = 0.618;
extern bool   T3Original             = false;
extern int    TmaPrice               = PRICE_CLOSE;
extern int    TmaHalfPeriod          = 5;
extern int    FirstBarForComparison  = 1;
extern int    SecondBarForComparison = 2;
extern bool   ShowComment            = true;
extern bool   alertsOn               = false;
extern int    alertsOnBar            = 0;
extern double alertsOnDistance       = 10;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;


//
//
//
//
//

double t3[];
double tma[];
double distance[];
double trend[];
double histUp[];
double histDn[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(6);
      SetIndexBuffer(0,histUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,histDn); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,t3);
      SetIndexBuffer(3,tma);
      SetIndexBuffer(4,distance);
      SetIndexBuffer(5,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" T3 - TMA combination ("+T3Period+","+TmaHalfPeriod+")");
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit=MathMin(MathMax(Bars-counted_bars,TmaHalfPeriod),Bars-1);
      if (returnBars) { histUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         t3[i]       = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i);
         tma[i]      = iTma(TmaPrice,TmaHalfPeriod,i);
         distance[i] = distance(i);
         trend[i]    = trend[i+1];
         histUp[i]   = EMPTY_VALUE;
         histDn[i]   = EMPTY_VALUE;
            if (t3[i]>tma[i]) trend[i] =  1;
            if (t3[i]<tma[i]) trend[i] = -1;
            if (trend[i] == 1) histUp[i] = 1;
            if (trend[i] ==-1) histDn[i] = 1;
      }
      
      //
      //
      //
      //
      //
      
      showDistances(distance[FirstBarForComparison],distance[SecondBarForComparison],ShowComment);
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Price,T3Period,T3Hot,T3Original,TmaPrice,TmaHalfPeriod,FirstBarForComparison,SecondBarForComparison,5,y);
         histUp[i]   = EMPTY_VALUE;
         histDn[i]   = EMPTY_VALUE;
            if (trend[i] == 1) histUp[i] = 1;
            if (trend[i] ==-1) histDn[i] = 1;
   }

   //
   //
   //
   //
   //      
   
      double dist1 = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Price,T3Period,T3Hot,T3Original,TmaPrice,TmaHalfPeriod,FirstBarForComparison,SecondBarForComparison,4,FirstBarForComparison);
      double dist2 = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Price,T3Period,T3Hot,T3Original,TmaPrice,TmaHalfPeriod,FirstBarForComparison,SecondBarForComparison,4,SecondBarForComparison);
      showDistances(dist1,dist2,ShowComment);
      manageAlerts();

   //
   //
   //
   //
   //
      
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      static datetime previousTime1=0;
      static datetime previousTime2=0;
      static string   previousMess1="";
      static string   previousMess2="";
      
      //
      //
      //
      //
      //
      
      double dist = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Price,T3Period,T3Hot,T3Original,TmaPrice,TmaHalfPeriod,FirstBarForComparison,SecondBarForComparison,2,alertsOnBar);
      if (MathAbs(dist)>alertsOnDistance)
               doAlert(0,"Distance at bar "+alertsOnBar+" exceded "+DoubleToStr(alertsOnDistance,1)+" pips",previousTime1,previousMess1);

      //
      //
      //
      //
      //
      
      int    whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,alertsOnBar));
      string desc     = " above TMA";
         if (trend[whichBar]== -1) desc = "bellow TMA";
               doAlert(0,"T3 at bar "+alertsOnBar+" is "+desc,previousTime2,previousMess2,true);
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat, datetime& previousTime, string& previousAlert, bool ignoreTime=false)
{
   string message;
   bool   condition;
 
   if (ignoreTime)
         condition = (previousAlert != doWhat) ;
   else  condition = (previousAlert != doWhat || previousTime != Time[forBar]);
   if (condition) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," T3 TMA - ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"T3 TMA"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

void showDistances(double dist1, double dist2, bool show)
{
   if (!calculateValue)
   if (show)
   {
      string comment = "\n";
             comment = comment+"distance at bar "+FirstBarForComparison +" : "+DoubleToStr(MathAbs(dist1),1)+" pips \n";
             comment = comment+"distance at bar "+SecondBarForComparison+" : "+DoubleToStr(MathAbs(dist2),1)+" pips \n";
             comment = comment+"change r "+DoubleToStr(MathAbs(dist1)-MathAbs(dist2),1)+" pips \n";
             Comment(comment);
   }
   else Comment("");            
}

//
//
//
//
//

double distance (int atBar)
{
   double dist = (t3[atBar]-tma[atBar])/Point; if (Digits==3 || Digits==5) dist /= 10.0;
   return(dist);
}
//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int shift, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int i = Bars-shift-1;
   if (i < 1)
      {
         workT3[i][0+buffer] = price;
         workT3[i][1+buffer] = price;
         workT3[i][2+buffer] = price;
         workT3[i][3+buffer] = price;
         workT3[i][4+buffer] = price;
         workT3[i][5+buffer] = price;
      }
   else
      {
         workT3[i][0+buffer] = workT3[i-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[i-1][0+buffer]);
         workT3[i][1+buffer] = workT3[i-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][0+buffer]-workT3[i-1][1+buffer]);
         workT3[i][2+buffer] = workT3[i-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][1+buffer]-workT3[i-1][2+buffer]);
         workT3[i][3+buffer] = workT3[i-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][2+buffer]-workT3[i-1][3+buffer]);
         workT3[i][4+buffer] = workT3[i-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][3+buffer]-workT3[i-1][4+buffer]);
         workT3[i][5+buffer] = workT3[i-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][4+buffer]-workT3[i-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[i][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[i][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[i][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[i][2+buffer]);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double iTma(int price, int halfLength, int i)
{
   int j,k;

   double sump = (halfLength+1)*iMA(NULL,0,1,0,MODE_SMA,price,i);
   double sumw = (halfLength+1);

   for(j=1, k=halfLength; j<=halfLength; j++, k--)
   {
      sump += k*iMA(NULL,0,1,0,MODE_SMA,price,i+j);
      sumw += k;

      if (j<=i)
      {
         sump += k*iMA(NULL,0,1,0,MODE_SMA,price,i-j);
         sumw += k;
      }
   }
   return(sump/sumw);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}